/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef EXCEPTION_HH
#define EXCEPTION_HH

#include "saturn.hh"

class FichierInexistant {
private:
  char nom[255];
public:
  FichierInexistant(char *);
  friend ostream& operator<<(ostream& os, const FichierInexistant&);
};

class MauvaisAcces {
private:
  unsigned long adresse;
public:
  MauvaisAcces(unsigned long);
  unsigned long getAdresse(void) const;
  friend ostream& operator<<(ostream&, const MauvaisAcces&);
};

class InstructionNonImplementee { // FIXME: devrait disparaitre...
public:
  char nom[5]; // FIXME
  InstructionNonImplementee(char *chaine) { strcpy(nom,chaine); }
};

class InstructionIllegale {
private:
  unsigned short code;
public:
  InstructionIllegale(unsigned short us) { code = us; }
  friend ostream& operator<<(ostream& os, const InstructionIllegale& il) {
    char chaine[11];
    sprintf(chaine, "%10X", il.code);
    os << chaine;
    return os;
  }
};

#endif
