/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "message.hh"

Message::Message(long type, char *texte) {
  strncpy(mtext, texte, 20);
  mtext[20] = '\0';
  mtype = type;
}

int Message::getLongueur(void) const {
  return 21;
}

char *Message::getTexte(void) {
  return mtext;
}

FileMessage::FileMessage(char c) {
  int cle = ftok("/usr/", c);
  msgid = msgget(cle,IPC_CREAT | 0600);
  if (msgid == -1) perror("constructeur");
}

void FileMessage::envoyer(const Message& message) {
  msgsnd(msgid,&message,message.getLongueur(),0);
}

bool FileMessage::recevoir(Message& message, long type) {
  return (msgrcv(msgid,&message,message.getLongueur(),type,IPC_NOWAIT) != -1);
}

bool FileMessage::recevoirBloquant(Message& message, long type) {
  return (msgrcv(msgid,&message,message.getLongueur(),type,0) != -1);
}

int FileMessage::nombreMessages(void) {
  struct msqid_ds infos;
  msgctl(msgid, IPC_STAT, &infos);
  return infos.msg_qnum;
}
