/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "superh.hh"
#include "message.hh"
#include <curses.h>

int main(int argc, char **argv) {
  cout << "ok\n";
  MemoireSaturn *mem = new MemoireSaturn(); 
  SuperH *proc = new(SH2) SuperH();

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush(stdscr, FALSE);
  keypad(stdscr, TRUE);
  nodelay(stdscr, TRUE);


  int c;
  int ymax, xmax;
  getmaxyx(stdscr,ymax, xmax);
  int largeur = (xmax / 12) * 12;
  int deca = (xmax - largeur)/2;

  mvaddch(1,deca - 1,ACS_ULCORNER);
  for(int i = 1;i < largeur + 1;i++) addch(ACS_HLINE);
  addch(ACS_URCORNER);
  for(int i = 2;i < 9;i++) mvaddch(i,deca + largeur,ACS_VLINE);
  mvaddch(9,deca + largeur,ACS_LRCORNER);
  for(int i = 2;i < 9;i++) mvaddch(i,deca - 1,ACS_VLINE);
  mvaddch(9,deca - 1,ACS_LLCORNER);
  for(int i = 1;i < largeur + 1;i++) addch(ACS_HLINE);

  mvaddch(10,deca + 2 * largeur / 3 - 1,ACS_ULCORNER);
  for(int i = 0;i < largeur/3;i++)
    addch(ACS_HLINE);
  addch(ACS_URCORNER);
  mvaddch(11,deca + 2 * largeur / 3 - 1,ACS_VLINE);
  mvaddch(11,deca + largeur,ACS_VLINE);
  mvaddch(12,deca + 2 * largeur / 3 - 1,ACS_LLCORNER);
  for(int i = 0;i < largeur/3;i++)
    addch(ACS_HLINE);
  addch(ACS_LRCORNER);

  mvprintw(14,deca,"(q)uitter le moniteur");
  mvprintw(15,deca,"(s)topper l'mulateur");
  
  while((c = getch()) != 'q') {
    
    // ARRET DU PROG PRINCIPAL
    if (c == 's') proc->stop = true;

    // EXECUTION PAS A PAS
    if (c == 'e') {
    }

    // AFFICHAGE
    for(int i = 0;i < 4;i++)
      for(int j = 0;j < 4;j++) {
	mvprintw(i + 2, deca + j * largeur/4 + 1, "R%d", 4 * i  + j);
	mvprintw(i+2, deca+(j+1) * largeur/4 - 11, "%10X", proc->R[4 * i + j]);
      }

    int l5 = ((largeur - 4) / 5) * 5;
    int r5 = largeur - l5;
    mvprintw(6,deca + 1,"SR");
    mvprintw(6,deca + r5 + 1,"M");
    mvprintw(6,deca + l5/5 + r5 - 2,"%1X",proc->SR.partie.M);
    mvprintw(6,deca + l5/5 + r5 + 1,"Q");
    mvprintw(6,deca + 2 * l5/5 + r5 - 2,"%1X",proc->SR.partie.Q);
    mvprintw(6,deca + 2 * l5/5 + r5 + 1,"I");
    mvprintw(6,deca + 3 * l5/5 + r5 - 2,"%1X",proc->SR.partie.I);
    mvprintw(6,deca + 3 * l5/5 + r5 + 1,"S");
    mvprintw(6,deca + 4 * l5/5 + r5 - 2,"%1X",proc->SR.partie.S);
    mvprintw(6,deca + 4 * l5/5 + r5 + 1,"T");
    mvprintw(6,deca + l5 + r5 - 2,"%1X",proc->SR.partie.T);

    mvprintw(7,deca + 1,"GBR");
    mvprintw(7,deca + largeur/3 - 11,"%10X",proc->GBR);
    mvprintw(7,deca + largeur/3 + 1,"MACH");
    mvprintw(7,deca + 2 * largeur/3 - 11,"%10X",proc->MACH);
    mvprintw(7,deca + 2 * largeur/3 + 1,"PR");
    mvprintw(7,deca + largeur - 11,"%10X",proc->PR);

    mvprintw(8,deca + 1,"VBR");
    mvprintw(8,deca + largeur/3 - 11,"%10X",proc->VBR);
    mvprintw(8,deca + largeur/3 + 1,"MACL");
    mvprintw(8,deca + 2 * largeur/3 - 11,"%10X",proc->MACL);
    mvprintw(8,deca + 2 * largeur/3 + 1,"PC");
    mvprintw(8,deca + largeur - 11,"%10X",proc->PC);

    try {
      if (proc->PC == 0) {
        mvprintw(11,deca + 2 * largeur/3 + 1,"@PC");
        mvprintw(11,deca + largeur - 11,"delay slot");
      }
      else {
        mvprintw(11,deca + 2 * largeur/3 + 1,"@PC");
        mvprintw(11,deca + largeur - 11,"%10X",mem->getMot(proc->PC - 4));
      }
    }
    catch (MauvaisAcces ma) {
      mvprintw(ymax - 1,0,"mauvais accs (PC = %10X)",
		      ma.getAdresse(), proc->PC - 4);
    }

  }
  endwin();

  proc->stop = true;

  delete proc;
  delete mem;
}
