/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "objet.hh"
#include "sem.hh"
#include "message.hh"

void *Objet::operator new(size_t taille, char c) {
  key_t clef;
  int shmid;
  void *adresse;

  clef = ftok("/", c);
  shmid = shmget(clef, taille, IPC_CREAT | 0600);
  adresse = shmat(shmid, NULL, 0);
  ((Objet *) adresse)->numero = c;

  FileMessage fm(SATURNE_MSG);
  Message message(c);
  fm.envoyer(message);

  return adresse;
}

void Objet::operator delete(void *adresse, size_t taille) {
  key_t clef;
  int shmid;
  int num = ((Objet *) adresse)->numero;

  clef = ftok("/", num);
  shmid = shmget(clef, taille, 0);
  shmdt(adresse);

  FileMessage fm(SATURNE_MSG);
  Message message(num);
  fm.recevoir(message, num);
  if (!fm.recevoir(message, num)) {
    if (shmctl(shmid, IPC_RMID, NULL) == -1) perror(NULL);
  }
  else fm.envoyer(message);
}

char Objet::clef(void) const {
  return numero;
}
