/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "sem.hh"

Semaphore::Semaphore(char c) {
	int clef = ftok("/",c);
	semid = semget(clef, 1, IPC_CREAT | 0600);
}

void Semaphore::init(int i) {
	semctl(semid, 0, SETVAL, i);
}

void Semaphore::P(void) {
	struct sembuf operation;

	operation.sem_num = 0;
	operation.sem_op = -1;
	operation.sem_flg = 0;
	semop(semid, &operation, 1);
}

void Semaphore::V(void) {
	struct sembuf operation;

	operation.sem_num = 0;
	operation.sem_op = 1;
	operation.sem_flg = 0;
	semop(semid, &operation, 1);
}

void Semaphore::supprimer(void) {
	semctl(semid, 0, IPC_RMID, 0);
}
