/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "cs1.hh"

Cs1::Cs1(void) : Registre("cs1", 0x1000000, CS1) {}

unsigned char Cs1::getOctet(unsigned long adr) { // merci satonem !!!
  if (adr >= taille) { throw MauvaisAcces(adr); }
  cerr << nom << "\t: " << hex << setw(10) << adr << " -> "
                               << setw(10) << 0xFF << endl;
  return 0xFF;
}

unsigned short Cs1::getMot(unsigned long adr) { // merci satonem !!!
  if (adr >= taille) { throw MauvaisAcces(adr); }
  cerr << nom << "\t: " << hex << setw(10) << adr << " -> "
                               << setw(10) << 0xFFFF << endl;
  return 0xFFFF;
}

unsigned long Cs1::getGrosmot(unsigned long adr) { // merci satonem !!!
  if (adr >= taille) { throw MauvaisAcces(adr); }
  cerr << nom << "\t: " << hex << setw(10) << adr << " -> "
                               << setw(10) << 0xFFFFFFFF << endl;
  return 0xFFFFFFFF;
}
