/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INTC_HH
#define INTC_HH

#include "memoire.hh"
#include "signal.h"
#include "message.hh"
#include "processeur.hh"

class RegistresIntc : public Memoire {
public:
  RegistresIntc(void);
  unsigned short	getIPRA(void);
  unsigned short	getIPRB(void);
  unsigned short	getVCRA(void);
  unsigned short	getVCRB(void);
  unsigned short	getVCRC(void);
  unsigned short	getVCRD(void);
  unsigned short	getVCRWDT(void);
  unsigned long		getVCRDIV(void);
  unsigned long		getVCRDMA(int);
  unsigned short	getICR(void);
  friend ostream& operator<<(ostream&, RegistresIntc&);
};

class MasterSH;

class Intc /*: public Processeur*/ {
private:
  static RegistresIntc memoire;
  static FileMessage fm;
  bool stop;
  MasterSH *proc;
public:
  static const int INT_NMI = 1;
  static const int INT_USER_BREAK = 2;
  static const int INT_IRL[15];
  static const int INT_DIVU = 18;
  static const int INT_DMAC = 19;
  static const int INT_WDT = 20;
  static const int INT_SCI = 21;
  static const int INT_FRT = 22;
  static const int INTC_STOP = 23;

  //Intc(void);
  void lancer(void);
  void executer(void);
};

#endif
