/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef OBJET_HH
#define OBJET_HH

#include "saturn.hh"
#include "sem.hh"
#include "message.hh"

template<char C>
class Objet {
private:
  static FileMessage fm;
public:
  void *operator new(size_t);
  void operator delete(void *, size_t);
};

template<char C> FileMessage Objet<C>::fm(SATURNE_MSG);

template<char C> void *Objet<C>::operator new(size_t taille) {
  key_t clef;
  int shmid;
  void *adresse;

  clef = ftok("/", C);
  shmid = shmget(clef, taille, IPC_CREAT | 0600);
  adresse = shmat(shmid, NULL, 0);

  Message message(C);
  fm.envoyer(message);

  return adresse;
}

template<char C> void Objet<C>::operator delete(void *adresse, size_t taille) {
  key_t clef;
  int shmid;

  clef = ftok("/", C);
  shmid = shmget(clef, taille, 0);
  shmdt(adresse);

  Message message(C);
  fm.recevoir(message, C);
  if (!fm.recevoir(message, C)) shmctl(shmid, IPC_RMID, NULL);
  else fm.envoyer(message);
}

#endif
