/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef VDP1_HH
#define VDP1_HH

#include "memoire.hh"
#include "processeur.hh"

class RegistresVdp1 : public Registre {
public:
  RegistresVdp1(void);
};

class Vdp1 : public Processeur {
private:
  Memoire *memoire;
  RegistresVdp1 *registres;
  bool inout;
public:
  Vdp1(void);
  ~Vdp1(void);
  void executer(unsigned long = 0);
  //void lancer(void);
  //void appelPeriodique();
  void normalSpriteDraw();
  void scaledSpriteDraw();
  void distortedSpriteDraw();
  void polygonDraw();
  void polylineDraw();
  void lineDraw();
  void userClipping();
  void systemClipping();
  void localCoordinate();
  void drawEnd();
};

#endif
