/*  Copyright 2003 Guillaume Duhamel

    This file is part of Yabause.

    Yabause is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Yabause is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Yabause; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "vdp2.hh"

RegistresVdp2::RegistresVdp2(void) : Registre("vdp2", 0x120, VDP2_3) {}

#include "message.hh"
#include "saturn.hh"
#include "intc.hh"

void Vdp2::executer(void) {
	FileMessage fm(INTC_MSG);
	char texte[2];
	texte[1] = 0x41;
	if (inout) {
		texte[0] = 0x40;
		Message interruption1(Intc::INT_IRL[14], texte);
		fm.envoyer(interruption1);
	}
	else {
		texte[0] = 0x41;
		Message interruption2(Intc::INT_IRL[13], texte);
		fm.envoyer(interruption2);
	}
	inout = !inout;
}
